#include <stdio.h>
#include <string.h>

const long MAX_UNIKA = 60;
const long MAX_QUEUE_LEN = 160;
const long INFINITY = 1000000000;
const long MAX_COST = 100000;

long MinAmount(long *costs, long cCosts, long sum)
{
	long iCost, startCost, cost, newCost;
	long minAmount[MAX_COST + 1];
	if(sum < 0)return INFINITY;

	for(iCost = 0, startCost = 0; iCost < cCosts; ++iCost)
		startCost += costs[iCost];

	if(startCost > sum)return INFINITY;
	
	for(cost = startCost; cost < sum; ++cost)
		minAmount[cost] = INFINITY;
	minAmount[sum] = INFINITY;
	minAmount[startCost] = cCosts;

	for(cost = startCost; cost < sum; ++cost)
		if(minAmount[cost] < INFINITY)
			for(iCost = 0; iCost < cCosts; ++iCost)
			{
				newCost = cost + (costs[iCost] << 1);
				if(newCost > sum)continue;
				if(minAmount[newCost] > minAmount[cost] + 2)
					minAmount[newCost] = minAmount[cost] + 2;		
			}
	return minAmount[sum];
}

struct Queue
{
	Queue()
	{
		head = tail = 0;
	}
	void In(long v)
	{
		data[tail++] = v;
	}
	long Out()
	{
		return data[head++];
	}
	int Empty()
	{
		return head == tail;
	}
	long data[MAX_QUEUE_LEN];
	long head, tail;
};

int main()
{	
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long iCase, cCases;
	scanf("%ld", &cCases);

	for(iCase = 0; iCase < cCases; ++iCase)
	{
		if(iCase > 0) putchar('\n');
		long matr[MAX_UNIKA][MAX_UNIKA];
		memset(matr, 0, sizeof(matr));
		long cUnika, cRoads, iRoad;
		scanf("%ld %ld", &cUnika, &cRoads);
		for(iRoad = 0; iRoad < cRoads; ++iRoad)
		{
			long src, dst, cst;
			scanf("%ld %ld %ld", &src, &dst, &cst);
			matr[--src][--dst] = cst;
			matr[dst][src] = cst;
		}
		long cQueries, iQuery;
		scanf("%ld", &cQueries);
		long used[MAX_UNIKA];
		long parent[MAX_UNIKA];
		for(iQuery = 0; iQuery < cQueries; ++iQuery)
		{
			Queue q;
			long idSrc, idDst, cost, currId;
			scanf("%ld %ld %ld", &idSrc, &idDst, &cost);
			--idDst;
			--idSrc;
			memset(used, 0, sizeof(used));
			memset(parent, -1, sizeof(parent));
			used[idSrc] = 1;
			q.In(idSrc);
			while(!q.Empty())
			{
				currId = q.Out();
				for(long iUnika = 0; iUnika < cUnika; ++iUnika)
				{
					if(matr[currId][iUnika] && !used[iUnika])
					{
						used[iUnika] = 1;
						q.In(iUnika);
						parent[iUnika] = currId;
					}
				}
			}
			if(!used[idDst])
			{
				printf("No\n");
				continue;
			}
			long way[MAX_UNIKA];
			long cWay = 0;
			for(long id = idDst; id != -1; id = parent[id])
			{
				way[cWay++] = id;
			}
			long c[MAX_UNIKA];
			for(long iWay=1; iWay<cWay-1; ++iWay)
			{
				c[iWay-1] = matr[way[iWay]][way[iWay+1]];
			}
			long res = MinAmount(c, cWay-2, cost-matr[way[0]][way[1]]);
			if(res == INFINITY)
			{
				printf("No\n");
			}
			else
			{
				printf("Yes %ld\n", res+1);
			}
		}
	}

#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif
	return 0;
}
